/**
 */
package de.mdelab.mlsdm;

import java.util.Map;

import org.eclipse.emf.common.util.DiagnosticChain;

import de.mdelab.mlcallactions.ParameterizedCallAction;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Activity Call Action</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Invokes another activity. The returnValue of this ActivityCallAction is determined by the value of returnValueParameter. In addtion, the flag importOutputParameters allows to import all output parameters of the activity, i.e., for each output parameter a variable will be created in the scope of the current activity. Existing variables will be overwritten.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.ActivityCallAction#getActivity <em>Activity</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.ActivityCallAction#getReturnValueParameter <em>Return Value Parameter</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.ActivityCallAction#isImportOutputParameters <em>Import Output Parameters</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityCallAction()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='CallActionTypeEqualsReturnParameterType'"
 * @generated
 */
public interface ActivityCallAction extends ParameterizedCallAction {
	/**
	 * Returns the value of the '<em><b>Activity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activity</em>' reference.
	 * @see #setActivity(Activity)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityCallAction_Activity()
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityCallAction!activity'"
	 * @generated
	 */
	Activity getActivity();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.ActivityCallAction#getActivity <em>Activity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Activity</em>' reference.
	 * @see #getActivity()
	 * @generated
	 */
	void setActivity(Activity value);

	/**
	 * Returns the value of the '<em><b>Return Value Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Return Value Parameter</em>' reference.
	 * @see #setReturnValueParameter(ActivityParameter)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityCallAction_ReturnValueParameter()
	 * @model annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityCallAction!returnValueParameter'"
	 * @generated
	 */
	ActivityParameter getReturnValueParameter();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.ActivityCallAction#getReturnValueParameter <em>Return Value Parameter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Return Value Parameter</em>' reference.
	 * @see #getReturnValueParameter()
	 * @generated
	 */
	void setReturnValueParameter(ActivityParameter value);

	/**
	 * Returns the value of the '<em><b>Import Output Parameters</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Import Output Parameters</em>' attribute.
	 * @see #setImportOutputParameters(boolean)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityCallAction_ImportOutputParameters()
	 * @model default="false" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityCallAction!importOutputParameters'"
	 * @generated
	 */
	boolean isImportOutputParameters();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.ActivityCallAction#isImportOutputParameters <em>Import Output Parameters</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Import Output Parameters</em>' attribute.
	 * @see #isImportOutputParameters()
	 * @generated
	 */
	void setImportOutputParameters(boolean value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'The type of this activity call action must be null because no returnValueParameter is selected.\',\n\tstatus : Boolean = \n\t\tif self.returnValueParameter = null then\n\t\t\tself.type = null\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"ActivityCallAction::CallActionTypeNullWhenNoReturnParameter\";\ntry {\n\t/**\n\t *\n\t * inv CallActionTypeNullWhenNoReturnParameter:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.returnValueParameter = null\n\t *           then self.type = null\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The type of this activity call action must be null because no returnValueParameter is selected.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmPackage%&gt;.Literals.ACTIVITY_CALL_ACTION___CALL_ACTION_TYPE_NULL_WHEN_NO_RETURN_PARAMETER__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; returnValueParameter = this.getReturnValueParameter();\n\t\tfinal /*@NonInvalid\052/ boolean eq = returnValueParameter == null;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = this.getType();\n\t\t\tfinal /*@NonInvalid\052/ boolean eq_0 = type == null;\n\t\t\tstatus = eq_0;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.TUPLid_, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_The_32_type_32_of_32_this_32_activity_32_call_32_action_32_must_32_be_32_null_32_because_32_no_32_re, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean CallActionTypeNullWhenNoReturnParameter(DiagnosticChain diagnostics, Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'The provided parameters do not match the activity\\\'s signature.\' ,\n\tstatus : Boolean = \n\t\tif self.activity &lt;&gt; null then\n\t\t\tself.activity.parameters-&gt;select( par | par.direction &lt;&gt; mlsdm::ActivityParameterDirectionEnum::OUT)-&gt;\n\t\t\t\tforAll( par | self.parameters-&gt;exists( par2 | par2.name = par.name and par2.type = par.type ) ) and\n\t\t\t\tself.parameters-&gt;forAll( par | self.activity.parameters-&gt;any( par2 | par2.name = par.name ).direction &lt;&gt; mlsdm::ActivityParameterDirectionEnum::OUT)\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"ActivityCallAction::ParametersMatchActivity\";\ntry {\n\t/**\n\t *\n\t * inv ParametersMatchActivity:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.activity &lt;&gt; null\n\t *           then\n\t *             self.activity.parameters-&gt;select(par | par.direction &lt;&gt; ActivityParameterDirectionEnum::OUT)\n\t *             -&gt;forAll(par |\n\t *               self.parameters-&gt;exists(par2 | par2.name = par.name and par2.type = par.type)) and\n\t *             self.parameters-&gt;forAll(par |\n\t *               self.activity.parameters-&gt;any(par2 | par2.name = par.name).direction &lt;&gt; ActivityParameterDirectionEnum::OUT)\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The provided parameters do not match the activity\\\'s signature.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.IdResolver%&gt; idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmPackage%&gt;.Literals.ACTIVITY_CALL_ACTION___PARAMETERS_MATCH_ACTIVITY__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_symbol_1;\n\t\ttry {\n\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_forAll;\n\t\t\ttry {\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.Activity%&gt; activity = this.getActivity();\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;&gt; parameters = activity.getParameters();\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; BOXED_parameters = idResolver.createSetOfAll(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.SET_CLSSid_ActivityParameter, parameters);\n\t\t\t\t/*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue.Accumulator%&gt; accumulator = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createSetAccumulatorValue(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.SET_CLSSid_ActivityParameter);\n\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par = BOXED_parameters.iterator();\n\t\t\t\t/*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; select;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_par.hasNext()) {\n\t\t\t\t\t\tselect = accumulator;\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; par = (&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;)ITERATOR_par.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * par.direction &lt;&gt; ActivityParameterDirectionEnum::OUT\n\t\t\t\t\t \052/\n\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameterDirectionEnum%&gt; direction = par.getDirection();\n\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_direction = &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ENUMid_ActivityParameterDirectionEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(direction.getName()));\n\t\t\t\t\tfinal /*@NonInvalid\052/ boolean ne = BOXED_direction != &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ELITid_OUT;\n\t\t\t\t\t//\n\t\t\t\t\tif (ne) {\n\t\t\t\t\t\taccumulator.add(par);\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par_0 = select.iterator();\n\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; forAll;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_par_0.hasNext()) {\n\t\t\t\t\t\tif (accumulator_0 == null) {\n\t\t\t\t\t\t\tforAll = null;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (accumulator_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\t\t\tforAll = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator_0;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; par_0 = (&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;)ITERATOR_par_0.next();\n\t\t\t\t\t/**\n\t\t\t\t\t *\n\t\t\t\t\t * self.parameters-&gt;exists(par2 | par2.name = par.name and par2.type = par.type)\n\t\t\t\t\t \052/\n\t\t\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_exists;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;&gt; parameters_0 = this.getParameters();\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.OrderedSetValue%&gt; BOXED_parameters_0 = idResolver.createOrderedSetOfAll(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ORD_CLSSid_CallActionParameter, parameters_0);\n\t\t\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par2 = BOXED_parameters_0.iterator();\n\t\t\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; exists;\n\t\t\t\t\t\twhile (true) {\n\t\t\t\t\t\t\tif (!ITERATOR_par2.hasNext()) {\n\t\t\t\t\t\t\t\tif (accumulator_1 == null) {\n\t\t\t\t\t\t\t\t\texists = null;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\telse if (accumulator_1 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\t\t\t\texists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator_1;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlcallactions.CallActionParameter%&gt; par2 = (&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;)ITERATOR_par2.next();\n\t\t\t\t\t\t\t/**\n\t\t\t\t\t\t\t * par2.name = par.name and par2.type = par.type\n\t\t\t\t\t\t\t \052/\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name = par2.getName();\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name_0 = par_0.getName();\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; and;\n\t\t\t\t\t\t\tif (!eq) {\n\t\t\t\t\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = par2.getType();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type_0 = par_0.getType();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ boolean eq_0 = (type != null) ? type.equals(type_0) : (type_0 == null);\n\t\t\t\t\t\t\t\tif (!eq_0) {\n\t\t\t\t\t\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t//\n\t\t\t\t\t\t\tif (and == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t\t\texists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse if (and == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse if (and == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\t\t\t\tif (accumulator_1 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\t\t\t\taccumulator_1 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\t\t\taccumulator_1 = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"exists\");\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t}\n\t\t\t\t\t\tCAUGHT_exists = exists;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\t\tCAUGHT_exists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\t//\n\t\t\t\t\tif (CAUGHT_exists == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\tforAll = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t}\n\t\t\t\t\telse if (CAUGHT_exists == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t}\n\t\t\t\t\telse if (CAUGHT_exists == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\t\tif (accumulator_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\t\t\taccumulator_0 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\telse if (CAUGHT_exists instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\t\taccumulator_0 = CAUGHT_exists;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t\t}\n\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\taccumulator_0 = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"forAll\");\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tCAUGHT_forAll = forAll;\n\t\t\t}\n\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\tCAUGHT_forAll = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t}\n\t\t\tfinal /*@Thrown\052/ &lt;%java.lang.Boolean%&gt; and_0;\n\t\t\tif (CAUGHT_forAll == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\tand_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_forAll_0;\n\t\t\t\ttry {\n\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;&gt; parameters_1 = this.getParameters();\n\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.OrderedSetValue%&gt; BOXED_parameters_1 = idResolver.createOrderedSetOfAll(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ORD_CLSSid_CallActionParameter, parameters_1);\n\t\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator_2 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par_1 = BOXED_parameters_1.iterator();\n\t\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; forAll_0;\n\t\t\t\t\twhile (true) {\n\t\t\t\t\t\tif (!ITERATOR_par_1.hasNext()) {\n\t\t\t\t\t\t\tif (accumulator_2 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\t\t\t\tforAll_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator_2;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t}\n\t\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlcallactions.CallActionParameter%&gt; par_1 = (&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;)ITERATOR_par_1.next();\n\t\t\t\t\t\t/**\n\t\t\t\t\t\t * self.activity.parameters-&gt;any(par2 | par2.name = par.name).direction &lt;&gt; ActivityParameterDirectionEnum::OUT\n\t\t\t\t\t\t \052/\n\t\t\t\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_ne_0;\n\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.Activity%&gt; activity_0 = this.getActivity();\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;&gt; parameters_2 = activity_0.getParameters();\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; BOXED_parameters_2 = idResolver.createSetOfAll(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.SET_CLSSid_ActivityParameter, parameters_2);\n\t\t\t\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par2_0 = BOXED_parameters_2.iterator();\n\t\t\t\t\t\t\t/*@Thrown\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; any;\n\t\t\t\t\t\t\twhile (true) {\n\t\t\t\t\t\t\t\tif (!ITERATOR_par2_0.hasNext()) {\n\t\t\t\t\t\t\t\t\tthrow new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(\"Nothing to return for \'\'any\'\'\");\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; par2_0 = (&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;)ITERATOR_par2_0.next();\n\t\t\t\t\t\t\t\t/**\n\t\t\t\t\t\t\t\t * par2.name = par.name\n\t\t\t\t\t\t\t\t \052/\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name_1 = par2_0.getName();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name_2 = par_1.getName();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ boolean eq_1 = (name_1 != null) ? name_1.equals(name_2) : (name_2 == null);\n\t\t\t\t\t\t\t\t//\n\t\t\t\t\t\t\t\tif (eq_1) {\t\t\t// Carry on till something found\n\t\t\t\t\t\t\t\t\tany = par2_0;\n\t\t\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%de.mdelab.mlsdm.ActivityParameterDirectionEnum%&gt; direction_0 = any.getDirection();\n\t\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_direction_0 = &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ENUMid_ActivityParameterDirectionEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(direction_0.getName()));\n\t\t\t\t\t\t\tfinal /*@Thrown\052/ boolean ne_0 = BOXED_direction_0 != &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ELITid_OUT;\n\t\t\t\t\t\t\tCAUGHT_ne_0 = ne_0;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\t\t\tCAUGHT_ne_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t\t\t}\n\t\t\t\t\t\t//\n\t\t\t\t\t\tif (CAUGHT_ne_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t\tforAll_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (CAUGHT_ne_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (CAUGHT_ne_0 instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\t\t\taccumulator_2 = CAUGHT_ne_0;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\t\taccumulator_2 = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"forAll\");\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tCAUGHT_forAll_0 = forAll_0;\n\t\t\t\t}\n\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\tCAUGHT_forAll_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\tif (CAUGHT_forAll_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\tand_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tif (CAUGHT_forAll instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\n\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)CAUGHT_forAll;\n\t\t\t\t\t}\n\t\t\t\t\tif (CAUGHT_forAll_0 instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\n\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)CAUGHT_forAll_0;\n\t\t\t\t\t}\n\t\t\t\t\tif ((CAUGHT_forAll == null) || (CAUGHT_forAll_0 == null)) {\n\t\t\t\t\t\tand_0 = null;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tand_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\t\t\tfinal /*@Thrown\052/ boolean eq_2 = and_0 == Boolean.TRUE;\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\t\tif (eq_2) {\n\t\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.TUPLid_, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_The_32_provided_32_parameters_32_do_32_not_32_match_32_the_32_activity_39_s_32_signature, and_0);\n\t\t\t\tsymbol_1 = symbol_0;\n\t\t\t}\n\t\t\tCAUGHT_symbol_1 = symbol_1;\n\t\t}\n\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\tCAUGHT_symbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, CAUGHT_symbol_1, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean ParametersMatchActivity(DiagnosticChain diagnostics, Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'A returnValueParameter must be selected.\' ,\n\tstatus : Boolean = \n\t\tif self.activity &lt;&gt; null and not self.activity.parameters-&gt;select( par | par.direction = mlsdm::ActivityParameterDirectionEnum::IN )-&gt;isEmpty() then\n\t\t\tself.returnValueParameter &lt;&gt; null\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"ActivityCallAction::ReturnValueParameterExists\";\ntry {\n\t/**\n\t *\n\t * inv ReturnValueParameterExists:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.activity &lt;&gt; null and\n\t *             not self.activity.parameters-&gt;select(par |\n\t *               (par.direction = ActivityParameterDirectionEnum::IN\n\t *               ))\n\t *             -&gt;isEmpty()\n\t *           then self.returnValueParameter &lt;&gt; null\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'A returnValueParameter must be selected.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.IdResolver%&gt; idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmPackage%&gt;.Literals.ACTIVITY_CALL_ACTION___RETURN_VALUE_PARAMETER_EXISTS__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@Thrown\052/ &lt;%java.lang.Boolean%&gt; and;\n\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.Activity%&gt; activity = this.getActivity();\n\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;&gt; parameters = activity.getParameters();\n\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; BOXED_parameters = idResolver.createSetOfAll(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.SET_CLSSid_ActivityParameter, parameters);\n\t\t/*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue.Accumulator%&gt; accumulator = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createSetAccumulatorValue(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.SET_CLSSid_ActivityParameter);\n\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par = BOXED_parameters.iterator();\n\t\t/*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.SetValue%&gt; select;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_par.hasNext()) {\n\t\t\t\tselect = accumulator;\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; par = (&lt;%de.mdelab.mlsdm.ActivityParameter%&gt;)ITERATOR_par.next();\n\t\t\t/**\n\t\t\t * par.direction = ActivityParameterDirectionEnum::IN\n\t\t\t \052/\n\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameterDirectionEnum%&gt; direction = par.getDirection();\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%&gt; BOXED_direction = &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ENUMid_ActivityParameterDirectionEnum.getEnumerationLiteralId(&lt;%org.eclipse.ocl.pivot.utilities.ClassUtil%&gt;.nonNullState(direction.getName()));\n\t\t\tfinal /*@NonInvalid\052/ boolean eq = BOXED_direction == &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.ELITid_IN;\n\t\t\t//\n\t\t\tif (eq) {\n\t\t\t\taccumulator.add(par);\n\t\t\t}\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean isEmpty = &lt;%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%&gt;.INSTANCE.evaluate(select).booleanValue();\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; not;\n\t\tif (!isEmpty) {\n\t\t\tnot = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tif (isEmpty) {\n\t\t\t\tnot = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tnot = null;\n\t\t\t}\n\t\t}\n\t\tand = (&lt;%java.lang.Boolean%&gt;)not;\n\t\tif (and == null) {\n\t\t\tthrow new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\tif (and) {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; returnValueParameter = this.getReturnValueParameter();\n\t\t\tfinal /*@NonInvalid\052/ boolean ne = returnValueParameter != null;\n\t\t\tstatus = ne;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.TUPLid_, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_A_32_returnValueParameter_32_must_32_be_32_selected, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean ReturnValueParameterExists(DiagnosticChain diagnostics, Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'The type of this activity call action must be equal to the type of the selected returnValueParameter.\',\n\tstatus : Boolean = \n\t\tif self.returnValueParameter &lt;&gt; null then\n\t\t\tself.type = self.returnValueParameter\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"ActivityCallAction::CallActionTypeEqualsReturnParameterType\";\ntry {\n\t/**\n\t *\n\t * inv CallActionTypeEqualsReturnParameterType:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.returnValueParameter &lt;&gt; null\n\t *           then self.type = self.returnValueParameter\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The type of this activity call action must be equal to the type of the selected returnValueParameter.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmPackage%&gt;.Literals.ACTIVITY_CALL_ACTION___CALL_ACTION_TYPE_EQUALS_RETURN_PARAMETER_TYPE__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%de.mdelab.mlsdm.ActivityParameter%&gt; returnValueParameter_0 = this.getReturnValueParameter();\n\t\tfinal /*@NonInvalid\052/ boolean ne = returnValueParameter_0 != null;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\tif (ne) {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = this.getType();\n\t\t\tfinal /*@NonInvalid\052/ boolean eq = (type != null) ? type.equals(returnValueParameter_0) : (returnValueParameter_0 == null);\n\t\t\tstatus = eq;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.TUPLid_, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_The_32_type_32_of_32_this_32_activity_32_call_32_action_32_must_32_be_32_equal_32_to_32_the_32_type_32, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean CallActionTypeEqualsReturnParameterType(DiagnosticChain diagnostics, Map<Object, Object> context);

} // ActivityCallAction
