package de.mdelab.mlsdm.diagram.custom.actions;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.common.ui.action.AbstractActionDelegate;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.ui.IObjectActionDelegate;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.diagram.custom.dialogs.ChooseActivityOutParameterDialog;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;

public class EditActivityFinalNodeReturnValueLabelExpressionAction extends AbstractActionDelegate implements IObjectActionDelegate
{

	ChooseActivityOutParameterDialog	parameterDialog;

	@Override
	protected void doRun(IProgressMonitor progressMonitor)
	{
		parameterDialog = new ChooseActivityOutParameterDialog(null);
		parameterDialog.setChangeCommandReceiver(this.getChangeCommandReceiver());
		parameterDialog.setNode(this.getModel());
		parameterDialog.setActivity(this.getActivity());
		parameterDialog.setEditPart(this.getEditPart());

		parameterDialog.open();
	}

	protected ActivityFinalNode getModel()
	{
		ActivityFinalNodeEditPart aaEditPart = this.getEditPart();
		return (ActivityFinalNode) ((View) aaEditPart.getModel()).getElement();
	}

	protected ActivityFinalNodeEditPart getEditPart()
	{
		return (ActivityFinalNodeEditPart) ((ActivityFinalNodeEditPart) getStructuredSelection().getFirstElement())
				.getParent();
	}

	protected TransactionalEditingDomain getChangeCommandReceiver()
	{
		return ((ActivityFinalNodeEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
	}

	protected Activity getActivity()
	{
		return (Activity) this.getExpressionOwner().eContainer();
	}

	protected EObject getExpressionOwner()
	{
		return ((View) ((ActivityFinalNodeEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

}
