package de.mdelab.mlsdm.diagram.custom.actions;



import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class EditStoryPatternObjectDirectAssignmentExpressionAction extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return ((StoryPatternObject) this.getExpressionOwner()).getType();
	}

	@Override
	protected MLExpression getExpression()
	{
		//return ((StoryPatternObject) this.getExpressionOwner()).getAssignmentExpression();
		MLExpression expr = (MLExpression) ((StoryPatternObject) this.getExpressionOwner()).getAssignmentExpression();
		if (expr == null){
			MLStringExpression exp2 = null;
			exp2 = MlexpressionsFactory.eINSTANCE.createMLStringExpression();
			exp2.setExpressionLanguageID("OCL");
			CompoundCommand cc = new CompoundCommand();
			StoryPatternObject spo = (StoryPatternObject) this.getExpressionOwner();
			TransactionalEditingDomain domain = TransactionUtil.getEditingDomain(spo);
			cc.append(domain.createCommand(SetCommand.class,
						new CommandParameter(spo, MlstorypatternsPackage.eINSTANCE.getStoryPatternObject_AssignmentExpression(),
								exp2)));
			Command command = cc.unwrap();
			if (!command.equals(UnexecutableCommand.INSTANCE))
			{
				domain.getCommandStack().execute(command);
			}
			expr = exp2;
		}

		return expr;

	}

	@Override
	protected TransactionalEditingDomain getEditingDomain()
	{
		return ((StoryPatternObjectEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
	}

//	@Override
//	protected void setNewExpression(MLExpression newExpression)
//	{
//		StoryPatternObject spo = (StoryPatternObject) this.getExpressionOwner();
//
//		spo.setAssignmentExpression(newExpression);
//	}

	@Override
	protected EClassifier getContextClassifier()
	{
		return ((StoryPatternObject) this.getExpressionOwner()).getType();
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = (StoryNode) ((View) ((StoryPatternObjectEditPart) getStructuredSelection().getFirstElement()).getModel())
				.getElement().eContainer().eContainer();

		while (!(container instanceof Activity))
		{
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return ((View) ((StoryPatternObjectEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setStructuralFeature(MlstorypatternsPackage.eINSTANCE.getStoryPatternObject_AssignmentExpression());
	}
}
