package de.mdelab.mlsdm.diagram.custom.actions;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditorPlugin;
import de.mdelab.mlsdm.ui.expressions.MlsdmEditStringExpressionDialog;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;

public class EditStoryPatternStringExpressionAction extends EditStringExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return EcorePackage.eINSTANCE.getEBoolean();
	}

	@Override
	protected MLExpression getExpression()
	{
		if (((View) ((IGraphicalEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement() instanceof MLExpression)
			return (MLExpression) ((View) ((IGraphicalEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
		return null;
	}
//
//	@Override
//	protected TransactionalEditingDomain getEditingDomain()
//	{
//		return ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
//	}
//
//	@Override
//	protected void setNewExpression(MLExpression newExpression)
//	{
//		MLExpression oldExpression = getExpression();
//		StoryPatternObject spo = (StoryPatternObject) oldExpression.eContainer();
//
//		spo.getConstraints().remove(oldExpression);
//		spo.getConstraints().add(newExpression);
//	}

	@Override
	protected EClassifier getContextClassifier()
	{
		/*StoryNode sN = (StoryNode) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent()
				.getModel()).getElement()
				sN.getStoryPattern().g;
		return ((StoryPatternObject) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent()
				.getModel()).getElement()).getType();*/
		return null;
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = ((StoryPattern) ((View) ((IGraphicalEditPart) getStructuredSelection().getFirstElement()).getParent()
				.getParent().getModel()).getElement()).eContainer();

		while (!(container instanceof Activity))
		{
			if (container==null) return null;
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return this.getExpression().eContainer();
	}

	@Override
	protected void prepareDialog()
	{		
//		MlsdmEditStringExpressionDialog dialog = new MlsdmEditStringExpressionDialog(null);
		//dialog.setActivity(getActivity());
		editExpressionDialog = new MlsdmEditStringExpressionDialog(	null,
																	MlsdmDiagramEditorPlugin.getInstance().getItemProvidersAdapterFactory() );
		editExpressionDialog.setExpression(getExpression());
		editExpressionDialog.setExpectedClassifier(getExpectedClassifier());
		editExpressionDialog.setContextClassifier(getContextClassifier());
		editExpressionDialog.setExpressionOwner(getExpressionOwner());
		editExpressionDialog.setEditingDomain(getEditingDomain());		
		
		editExpressionDialog.setRootContainer(getActivity());
		
		editExpressionDialog.setActivity(getActivity());
		
		final EStructuralFeature feature;
		
		final EObject container = getExpressionOwner();
		
		if ( MlstorypatternsPackage.Literals.STORY_PATTERN.isInstance( container ) ) {
			feature = MlstorypatternsPackage.Literals.STORY_PATTERN__CONSTRAINTS;
		}
		else {
			feature = MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__CONSTRAINTS;
		}
			
		editExpressionDialog.setStructuralFeature( feature );
	}
}
