package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.EditPartUtil;


public class CustomMapEntryLinkEditPart extends MapEntryLinkEditPart
{

	public CustomMapEntryLinkEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getEventType() != Notification.REMOVE
				&& (notification.getNotifier() instanceof MapEntryLink || notification.getNotifier() instanceof StoryPatternObject))
		{
			adaptColor();
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColor();
	}

	protected void adaptColor()
	{
		ModifierEnum modifier = ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier();

		EditPartUtil.adaptColor(getPrimaryShape(), modifier);

		for (Object o : getPrimaryShape().getChildren())
		{
			EditPartUtil.adaptColor((IFigure) o, modifier);
		}

		EditPartUtil.adaptLineStyle(getPrimaryShape(), ((MapEntryLink) ((View) this.getModel()).getElement()).getMatchType());
	}
}
