package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel10EditPart;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.EditPartUtil;

public class CustomMapEntryLinkFeatureNameLabelEditPart extends WrappingLabel10EditPart
{

	public CustomMapEntryLinkFeatureNameLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		if (event.getNotifier() instanceof MapEntryLink)
		{
			adaptColorAndLabelText();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColorAndLabelText();
	}

	protected void adaptColorAndLabelText()
	{
		((WrappingLabel) getFigure()).setTextWrap(true);
		((WrappingLabel) getFigure()).setTextJustification(PositionConstants.CENTER);

		EditPartUtil.adaptColor(getFigure(), ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());

		MapEntryLink link = (MapEntryLink) ((View) getModel()).getElement();

		String modifierString = EditPartUtil.adaptStoryPatternElementModifierText(this);

		if (!"".equals(modifierString))
		{
			modifierString += System.getProperty("line.separator");
		}

		if (link.getFeature() == null)
		{
			setLabelText(modifierString + "[null]");
		}
		else
		{
			setLabelText(modifierString + link.getFeature().getName());
		}
	}
}
