package de.mdelab.mlsdm.diagram.custom.edit.parts;


import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MlsdmEditPartFactory;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternConstraintsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel10EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel11EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel12EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel13EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel15EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel4EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel5EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel6EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel7EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel8EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel9EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabelEditPart;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.CustomAttributeAssignmentEditPart;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.CustomMLStringExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.CustomStoryPatternContainmentLinkEditPart;

public class CustomMlsdmEditPartFactory extends MlsdmEditPartFactory {

	@Override
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			
			switch (MlsdmVisualIDRegistry.getVisualID(view)) {
				case ActivityEditPart.VISUAL_ID:
					return new CustomActivityEditPart(view);

				case StoryNodeEditPart.VISUAL_ID:
					return new CustomStoryNodeEditPart(view);
					
				case StoryNode2EditPart.VISUAL_ID:
					return new CustomStoryNode2EditPart(view);

				case StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID:
					return new CustomStoryNodeStoryNodeElementsCompartmentEditPart(view);
					
				case StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID:
					return new CustomStoryPatternStoryPatternConstraintsCompartmentEditPart(view);
					
				case StoryPatternObjectEditPart.VISUAL_ID:
					return new CustomStoryPatternObjectEditPart(view);

				case MLStringExpressionEditPart.VISUAL_ID:
					return new CustomMLStringExpression2EditPart(view);

				case MLStringExpression3EditPart.VISUAL_ID:
					return new CustomMLStringExpression3EditPart(view);

				case CallActionExpressionEditPart.VISUAL_ID:
					return new CustomCallActionExpressionEditPart(view);
					
				case CallActionExpression2EditPart.VISUAL_ID:
					return new CustomCallActionExpression2EditPart(view);
					
				case CallActionExpression3EditPart.VISUAL_ID:
					return new CustomCallActionExpression3EditPart(view);

				case StoryPatternEditPart.VISUAL_ID:
					return new CustomStoryPatternEditPart(view);
			
				case WrappingLabel4EditPart.VISUAL_ID:
					return new CustomActivityEdgeGuardConstraintLabelEditPart(view);

				case WrappingLabelEditPart.VISUAL_ID:
					return new CustomActivityFinalNodeReturnValueLabelEditPart(view);
					
				case WrappingLabel3EditPart.VISUAL_ID:
					return new CustomActivityFinalNodeReturnValueLabelEditPart(view);
					
				case WrappingLabel2EditPart.VISUAL_ID:
					return new CustomInitialNodeSpecificationLabelEditPart(view);
					
				case WrappingLabel13EditPart.VISUAL_ID:
					return new CustomInitialNodeSpecificationLabel2EditPart(view);

				//#### Ab hier Story Pattern Teil kopiert, aber muss auf die entsprechenden WrappingLabels angepasst werden (da noch keine ATL Regeln)
				case AttributeAssignmentEditPart.VISUAL_ID:
					return new CustomAttributeAssignmentEditPart(view);
					
				case MLStringExpression2EditPart.VISUAL_ID:
					return new CustomMLStringExpressionEditPart(view);

				case LinkOrderConstraintEditPart.VISUAL_ID:
					return new CustomLinkOrderConstraintEditPart(view);

				case ContainmentLinkEditPart.VISUAL_ID:
					return new CustomStoryPatternContainmentLinkEditPart(view);

				case WrappingLabel7EditPart.VISUAL_ID:
					return new CustomStoryPatternLinkFeatureNameLabelEditPart(view);

				case WrappingLabel8EditPart.VISUAL_ID:
					return new CustomLinkPositionConstraintLabelEditPart(view);

				case WrappingLabel6EditPart.VISUAL_ID:
					return new CustomStoryPatternObjectModifierLabelEditPart(view);

				case WrappingLabel5EditPart.VISUAL_ID:
					return new CustomStoryPatternObjectClassifierLabelEditPart(view);

				case StoryPatternObjectNameEditPart.VISUAL_ID:
					return new CustomStoryPatternObjectNameLabelEditPart(view);
					
				case WrappingLabel9EditPart.VISUAL_ID:
					return new CustomStoryExpressionLinkLabelEditPart(view);
					
				case ExpressionLinkEditPart.VISUAL_ID:
					return new CustomExpressionLinkEditPart (view);

				case StoryPatternLinkEditPart.VISUAL_ID:
					return new CustomStoryPatternLinkEditPart(view);
					
				case MapEntryLinkEditPart.VISUAL_ID:
					return new CustomMapEntryLinkEditPart(view);

				case WrappingLabel10EditPart.VISUAL_ID:
					return new CustomMapEntryLinkFeatureNameLabelEditPart(view);

				case MapEntryLinkValueTargetEditPart.VISUAL_ID:
					return new CustomMapEntryLinkValueTargetEditPart(view);

				case WrappingLabel11EditPart.VISUAL_ID:
					return new CustomMapEntryLinkKeyLabelEditPart(view);

				case WrappingLabel12EditPart.VISUAL_ID:
					return new CustomMapEntryLinkValueLinkLabelEditPart(view);
				
				case WrappingLabel15EditPart.VISUAL_ID:
					return new CustomLinkOrderConstraintLabelEditPart(view);
			}
		}
		
		return super.createEditPart(context, model);
	}
}
