package de.mdelab.mlsdm.diagram.custom.edit.parts;


import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.EditPartUtil;



public class CustomStoryPatternObjectEditPart extends StoryPatternObjectEditPart
{

	public CustomStoryPatternObjectEditPart(View view)
	{
		super(view);
		updateFigure();
	}

	@Override
	protected IFigure createNodeShape()
	{
		StoryPatternObjectFigure figure = new StoryPatternObjectFigure();
		return primaryShape = (IFigure) figure;
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getNotifier() instanceof StoryPatternObject)
		{
			updateFigure();
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();
	}

	protected void updateFigure()
	{
		StoryPatternObject spo = (StoryPatternObject) ((View) getModel()).getElement();
		/*if (spo.getMatchType() == MatchTypeEnum.NEGATIVE)
		{
			IFigure crossFigure = (IFigure) ((IFigure) getFigure().getChildren().get(0)).getChildren().get(1);
			crossFigure.setVisible(true);
		}
		else*/ if (spo.getMatchType() == MatchTypeEnum.OPTIONAL)
		{
			//IFigure crossFigure = (IFigure) ((IFigure) getFigure().getChildren().get(0)).getChildren().get(1);
			//crossFigure.setVisible(false);
			RectangleFigure outerRectangle = ((RectangleFigure) ((IFigure) ((RectangleFigure) getFigure().getChildren().get(0))
					.getChildren().get(0)).getChildren().get(0));
			outerRectangle.setLineStyle(Graphics.LINE_DASH);
			((RectangleFigure) outerRectangle.getChildren().get(0)).setLineStyle(Graphics.LINE_DASH);
		}
		else
		{
			//IFigure crossFigure = (IFigure) ((IFigure) getFigure().getChildren().get(0)).getChildren().get(1);
			//crossFigure.setVisible(false);

			RectangleFigure outerRectangle = ((RectangleFigure) ((IFigure) ((RectangleFigure) getFigure().getChildren().get(0))
					.getChildren().get(0)).getChildren().get(0));
			outerRectangle.setLineStyle(Graphics.LINE_SOLID);
			((RectangleFigure) outerRectangle.getChildren().get(0)).setLineStyle(Graphics.LINE_SOLID);

		}

		EditPartUtil.adaptColor((IFigure) ((IFigure) ((IFigure) getFigure().getChildren().get(0)).getChildren().get(0)).getChildren().get(0),
				((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());

	}
//
//	@Override
//	protected void createDefaultEditPolicies()
//	{
//		super.createDefaultEditPolicies();
//		//installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new CustomStoryPatternObjectItemSemanticEditPolicy());
//	}

	public class StoryPatternObjectFigure extends
			de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart.StoryPatternObjectFigureDescriptor//mlstorypatterns.diagram.edit.parts.StoryPatternObjectEditPart.StoryPatternObjectFigureDescriptor
	{

		public StoryPatternObjectFigure()
		{
			super();
			if (((View) CustomStoryPatternObjectEditPart.this.getModel()).getElement() instanceof StoryPatternElement){
				EditPartUtil.adaptColor(this,
						((StoryPatternElement) ((View) CustomStoryPatternObjectEditPart.this.getModel()).getElement()).getModifier());
			}
		}
	}

}
