package de.mdelab.mlsdm.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyReferenceCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPattern2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternConstraintsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class StoryPattern2ItemSemanticEditPolicy extends MlsdmBaseItemSemanticEditPolicy
{

	/**
	 * @generated
	 */
	public StoryPattern2ItemSemanticEditPolicy()
	{
		super(MlsdmElementTypes.StoryPattern_3017);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req)
	{
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null)
		{
			// there are indirectly referenced children, need extra commands: false
			addDestroyChildNodesCommand(cmd);
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		}
		else
		{
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	private void addDestroyChildNodesCommand(ICompositeCommand cmd)
	{
		View view = (View) getHost().getModel();
		for (Iterator<?> nit = view.getChildren().iterator(); nit.hasNext();)
		{
			Node node = (Node) nit.next();
			switch (MlsdmVisualIDRegistry.getVisualID(node))
			{
				case StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID:
					for (Iterator<?> cit = node.getChildren().iterator(); cit.hasNext();)
					{
						Node cnode = (Node) cit.next();
						switch (MlsdmVisualIDRegistry.getVisualID(cnode))
						{
							case StoryPatternObjectEditPart.VISUAL_ID:
								for (Iterator<?> it = cnode.getTargetEdges().iterator(); it.hasNext();)
								{
									Edge incomingLink = (Edge) it.next();
									if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == StoryPatternLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == ContainmentLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == ExpressionLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == MapEntryLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == MapEntryLinkValueTargetEditPart.VISUAL_ID)
									{
										DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(),
												null, incomingLink.getTarget().getElement(), false);
										cmd.add(new DestroyReferenceCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
										continue;
									}
								}
								for (Iterator<?> it = cnode.getSourceEdges().iterator(); it.hasNext();)
								{
									Edge outgoingLink = (Edge) it.next();
									if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == StoryPatternLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == ContainmentLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == ExpressionLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
										continue;
									}
									if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == MapEntryLinkEditPart.VISUAL_ID)
									{
										DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
										cmd.add(new DestroyElementCommand(r));
										cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
										continue;
									}
								}
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
							case StoryPattern2EditPart.VISUAL_ID:
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
						}
					}
					break;
				case StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID:
					for (Iterator<?> cit = node.getChildren().iterator(); cit.hasNext();)
					{
						Node cnode = (Node) cit.next();
						switch (MlsdmVisualIDRegistry.getVisualID(cnode))
						{
							case MLStringExpression3EditPart.VISUAL_ID:
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
							case CallActionExpression3EditPart.VISUAL_ID:
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
						}
					}
					break;
			}
		}
	}

}
