package de.mdelab.mlsdm.diagram.part;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PaletteSeparator;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class MlsdmPaletteFactory
{

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot)
	{
		paletteRoot.add(createActivityNodesTools1Group());
		paletteRoot.add(createStoryPatternTools2Group());
		paletteRoot.add(createMisreferencedtools3Group());
	}

	/**
	 * Creates "Activity Nodes Tools" palette tool group
	 * @generated
	 */
	private PaletteContainer createActivityNodesTools1Group()
	{
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.ActivityNodesTools1Group_title);
		paletteContainer.setId("createActivityNodesTools1Group"); //$NON-NLS-1$
		paletteContainer.add(createInitialNode1CreationTool());
		paletteContainer.add(createActivityFinalNode2CreationTool());
		paletteContainer.add(createFlowFinalNode3CreationTool());
		paletteContainer.add(createDecisionMergeNode4CreationTool());
		paletteContainer.add(createForkJoinNode5CreationTool());
		paletteContainer.add(createExpressionActivityNode6CreationTool());
		paletteContainer.add(createStoryNode7CreationTool());
		paletteContainer.add(createStructuredNode8CreationTool());
		paletteContainer.add(new PaletteSeparator());
		paletteContainer.add(createActivityEdge10CreationTool());
		paletteContainer.add(new PaletteSeparator());
		return paletteContainer;
	}

	/**
	 * Creates "Story Pattern Tools" palette tool group
	 * @generated NOT
	 */
	private PaletteContainer createStoryPatternTools2Group()
	{
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.StoryPatternTools2Group_title);
		paletteContainer.setId("createStoryPatternTools2Group"); //$NON-NLS-1$
		paletteContainer.add(createStoryPattern1CreationTool());
		paletteContainer.add(createNegativeStoryPattern2CreationTool());
		paletteContainer.add(createStringExpression1CreationTool());
		paletteContainer.add(createCallActionExpression2CreationTool());
		paletteContainer.add(createStoryPatternObject3CreationTool());
		paletteContainer.add(createAttributeAssignment4CreationTool());
		paletteContainer.add(createStoryPatternLink5CreationTool());
		paletteContainer.add(createStoryPatternContainmentLink6CreationTool());
		paletteContainer.add(createStoryPatternExpressionLink7CreationTool());
		paletteContainer.add(createLinkOrderConstraint8CreationTool());
		paletteContainer.add(createMapEntryLink9CreationTool());
		paletteContainer.add(createMapEntryLinkValueLink10CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "-- Mis-referenced tools --" palette tool group
	 * @generated NOT
	 */
	private PaletteContainer createMisreferencedtools3Group()
	{
		PaletteGroup paletteContainer = new PaletteGroup(Messages.Misreferencedtools3Group_title);
		paletteContainer.setId("createMisreferencedtools3Group"); //$NON-NLS-1$
		paletteContainer.setDescription(Messages.Misreferencedtools3Group_desc);
		/*paletteContainer.add(createStringExpression1CreationTool());
		paletteContainer.add(createCallActionExpression2CreationTool());
		paletteContainer.add(createStoryPatternObject3CreationTool());
		paletteContainer.add(createAttributeAssignment4CreationTool());
		paletteContainer.add(createStoryPatternLink5CreationTool());
		paletteContainer.add(createStoryPatternContainmentLink6CreationTool());
		paletteContainer.add(createStoryPatternExpressionLink7CreationTool());
		paletteContainer.add(createLinkOrderConstraint8CreationTool());
		paletteContainer.add(createMapEntryLink9CreationTool());
		paletteContainer.add(createMapEntryLinkValueLink10CreationTool());*/
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createInitialNode1CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.InitialNode_2004);
		types.add(MlsdmElementTypes.InitialNode_3010);
		NodeToolEntry entry = new NodeToolEntry(Messages.InitialNode1CreationTool_title, Messages.InitialNode1CreationTool_desc, types);
		entry.setId("createInitialNode1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.InitialNode_2004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createActivityFinalNode2CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.ActivityFinalNode_2002);
		types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		NodeToolEntry entry = new NodeToolEntry(Messages.ActivityFinalNode2CreationTool_title,
				Messages.ActivityFinalNode2CreationTool_desc, types);
		entry.setId("createActivityFinalNode2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.ActivityFinalNode_2002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createFlowFinalNode3CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.FlowFinalNode_2007);
		types.add(MlsdmElementTypes.FlowFinalNode_3008);
		NodeToolEntry entry = new NodeToolEntry(Messages.FlowFinalNode3CreationTool_title, Messages.FlowFinalNode3CreationTool_desc, types);
		entry.setId("createFlowFinalNode3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.FlowFinalNode_2007));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDecisionMergeNode4CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.DecisionMergeNode_2006);
		types.add(MlsdmElementTypes.DecisionMergeNode_3006);
		NodeToolEntry entry = new NodeToolEntry(Messages.DecisionMergeNode4CreationTool_title,
				Messages.DecisionMergeNode4CreationTool_desc, types);
		entry.setId("createDecisionMergeNode4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.DecisionMergeNode_2006));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createForkJoinNode5CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.ForkJoinNode_2003);
		types.add(MlsdmElementTypes.ForkJoinNode_3009);
		NodeToolEntry entry = new NodeToolEntry(Messages.ForkJoinNode5CreationTool_title, Messages.ForkJoinNode5CreationTool_desc, types);
		entry.setId("createForkJoinNode5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.ForkJoinNode_2003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createExpressionActivityNode6CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
		types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
		NodeToolEntry entry = new NodeToolEntry(Messages.ExpressionActivityNode6CreationTool_title,
				Messages.ExpressionActivityNode6CreationTool_desc, types);
		entry.setId("createExpressionActivityNode6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.ExpressionActivityNode_2001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryNode7CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.StoryNode_2008);
		types.add(MlsdmElementTypes.StoryNode_3011);
		NodeToolEntry entry = new NodeToolEntry(Messages.StoryNode7CreationTool_title, Messages.StoryNode7CreationTool_desc, types);
		entry.setId("createStoryNode7CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.StoryNode_2008));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStructuredNode8CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MlsdmElementTypes.StructuredNode_2009);
		types.add(MlsdmElementTypes.StructuredNode_3018);
		NodeToolEntry entry = new NodeToolEntry(Messages.StructuredNode8CreationTool_title, Messages.StructuredNode8CreationTool_desc,
				types);
		entry.setId("createStructuredNode8CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.StructuredNode_2009));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createActivityEdge10CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.ActivityEdge10CreationTool_title, Messages.ActivityEdge10CreationTool_desc,
				Collections.singletonList(MlsdmElementTypes.ActivityEdge_4001));
		entry.setId("createActivityEdge10CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.ActivityEdge_4001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPattern1CreationTool()
	{
		NodeToolEntry entry = new NodeToolEntry(Messages.StoryPattern1CreationTool_title, Messages.StoryPattern1CreationTool_desc,
				Collections.singletonList(MlsdmElementTypes.StoryPattern_3002));
		entry.setId("createStoryPattern1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.StoryPattern_3002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createNegativeStoryPattern2CreationTool()
	{
		NodeToolEntry entry = new NodeToolEntry(Messages.NegativeStoryPattern2CreationTool_title,
				Messages.NegativeStoryPattern2CreationTool_desc, Collections.singletonList(MlsdmElementTypes.StoryPattern_3017));
		entry.setId("createNegativeStoryPattern2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.StoryPattern_3017));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStringExpression1CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(3);
		types.add(MlsdmElementTypes.MLStringExpression_3001);
		types.add(MlsdmElementTypes.MLStringExpression_3004);
		types.add(MlsdmElementTypes.MLStringExpression_3014);
		NodeToolEntry entry = new NodeToolEntry(Messages.StringExpression1CreationTool_title, Messages.StringExpression1CreationTool_desc,
				types);
		entry.setId("createStringExpression1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.MLStringExpression_3001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallActionExpression2CreationTool()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(3);
		types.add(MlsdmElementTypes.CallActionExpression_3013);
		types.add(MlsdmElementTypes.CallActionExpression_3012);
		types.add(MlsdmElementTypes.CallActionExpression_3015);
		NodeToolEntry entry = new NodeToolEntry(Messages.CallActionExpression2CreationTool_title,
				Messages.CallActionExpression2CreationTool_desc, types);
		entry.setId("createCallActionExpression2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.CallActionExpression_3013));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternObject3CreationTool()
	{
		NodeToolEntry entry = new NodeToolEntry(Messages.StoryPatternObject3CreationTool_title,
				Messages.StoryPatternObject3CreationTool_desc, Collections.singletonList(MlsdmElementTypes.StoryPatternObject_3003));
		entry.setId("createStoryPatternObject3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.StoryPatternObject_3003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAttributeAssignment4CreationTool()
	{
		NodeToolEntry entry = new NodeToolEntry(Messages.AttributeAssignment4CreationTool_title,
				Messages.AttributeAssignment4CreationTool_desc, Collections.singletonList(MlsdmElementTypes.AttributeAssignment_3005));
		entry.setId("createAttributeAssignment4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.AttributeAssignment_3005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternLink5CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.StoryPatternLink5CreationTool_title, Messages.StoryPatternLink5CreationTool_desc,
				Collections.singletonList(MlsdmElementTypes.StoryPatternLink_4002));
		entry.setId("createStoryPatternLink5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.StoryPatternLink_4002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternContainmentLink6CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.StoryPatternContainmentLink6CreationTool_title,
				Messages.StoryPatternContainmentLink6CreationTool_desc, Collections.singletonList(MlsdmElementTypes.ContainmentLink_4003));
		entry.setId("createStoryPatternContainmentLink6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.ContainmentLink_4003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternExpressionLink7CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.StoryPatternExpressionLink7CreationTool_title,
				Messages.StoryPatternExpressionLink7CreationTool_desc, Collections.singletonList(MlsdmElementTypes.ExpressionLink_4004));
		entry.setId("createStoryPatternExpressionLink7CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.ExpressionLink_4004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createLinkOrderConstraint8CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.LinkOrderConstraint8CreationTool_title,
				Messages.LinkOrderConstraint8CreationTool_desc, Collections.singletonList(MlsdmElementTypes.LinkOrderConstraint_4005));
		entry.setId("createLinkOrderConstraint8CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.LinkOrderConstraint_4005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMapEntryLink9CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.MapEntryLink9CreationTool_title, Messages.MapEntryLink9CreationTool_desc,
				Collections.singletonList(MlsdmElementTypes.MapEntryLink_4006));
		entry.setId("createMapEntryLink9CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.MapEntryLink_4006));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMapEntryLinkValueLink10CreationTool()
	{
		LinkToolEntry entry = new LinkToolEntry(Messages.MapEntryLinkValueLink10CreationTool_title,
				Messages.MapEntryLinkValueLink10CreationTool_desc,
				Collections.singletonList(MlsdmElementTypes.MapEntryLinkValueTarget_4007));
		entry.setId("createMapEntryLinkValueLink10CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlsdmElementTypes.getImageDescriptor(MlsdmElementTypes.MapEntryLinkValueTarget_4007));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry
	{

		/**
		 * @generated
		 */
		private final List<IElementType>	elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description, List<IElementType> elementTypes)
		{
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool()
		{
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry
	{

		/**
		 * @generated
		 */
		private final List<IElementType>	relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description, List<IElementType> relationshipTypes)
		{
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool()
		{
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
