package de.mdelab.mlsdm.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;

import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPattern2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNodeEditPart;
import de.mdelab.mlsdm.diagram.part.Messages;
import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditorPlugin;

/**
 * @generated
 */
public class MlsdmModelingAssistantProvider extends ModelingAssistantProvider
{

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host)
	{
		IGraphicalEditPart editPart = (IGraphicalEditPart) host.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof ActivityEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(8);
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			return types;
		}
		if (editPart instanceof ExpressionActivityNodeEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(2);
			types.add(MlsdmElementTypes.MLStringExpression_3001);
			types.add(MlsdmElementTypes.CallActionExpression_3013);
			return types;
		}
		if (editPart instanceof StructuredNodeEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(8);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
			return types;
		}
		if (editPart instanceof StoryPatternEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(2);
			types.add(MlsdmElementTypes.MLStringExpression_3014);
			types.add(MlsdmElementTypes.CallActionExpression_3015);
			return types;
		}
		if (editPart instanceof StoryPatternObjectEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(3);
			types.add(MlsdmElementTypes.MLStringExpression_3004);
			types.add(MlsdmElementTypes.CallActionExpression_3012);
			types.add(MlsdmElementTypes.AttributeAssignment_3005);
			return types;
		}
		if (editPart instanceof StoryPattern2EditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(2);
			types.add(MlsdmElementTypes.MLStringExpression_3014);
			types.add(MlsdmElementTypes.CallActionExpression_3015);
			return types;
		}
		if (editPart instanceof ExpressionActivityNode2EditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(2);
			types.add(MlsdmElementTypes.MLStringExpression_3001);
			types.add(MlsdmElementTypes.CallActionExpression_3013);
			return types;
		}
		if (editPart instanceof StructuredNode2EditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(8);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
			return types;
		}
		if (editPart instanceof StoryNodeStoryNodeElementsCompartmentEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(1);
			types.add(MlsdmElementTypes.StoryPattern_3002);
			return types;
		}
		if (editPart instanceof StoryPatternStoryPatternElementsCompartmentEditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(2);
			types.add(MlsdmElementTypes.StoryPatternObject_3003);
			types.add(MlsdmElementTypes.StoryPattern_3017);
			return types;
		}
		if (editPart instanceof StoryPatternStoryPatternElementsCompartment2EditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(2);
			types.add(MlsdmElementTypes.StoryPatternObject_3003);
			types.add(MlsdmElementTypes.StoryPattern_3017);
			return types;
		}
		if (editPart instanceof StoryNodeStoryNodeElementsCompartment2EditPart)
		{
			ArrayList<IElementType> types = new ArrayList<IElementType>(1);
			types.add(MlsdmElementTypes.StoryPattern_3002);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSource(IAdaptable source)
	{
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ActivityFinalNodeEditPart)
		{
			return ((ActivityFinalNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof DecisionMergeNodeEditPart)
		{
			return ((DecisionMergeNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ExpressionActivityNodeEditPart)
		{
			return ((ExpressionActivityNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof FlowFinalNodeEditPart)
		{
			return ((FlowFinalNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ForkJoinNodeEditPart)
		{
			return ((ForkJoinNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof InitialNodeEditPart)
		{
			return ((InitialNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof StoryNodeEditPart)
		{
			return ((StoryNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof StructuredNodeEditPart)
		{
			return ((StructuredNodeEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof StoryPatternObjectEditPart)
		{
			return ((StoryPatternObjectEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof DecisionMergeNode2EditPart)
		{
			return ((DecisionMergeNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ExpressionActivityNode2EditPart)
		{
			return ((ExpressionActivityNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof FlowFinalNode2EditPart)
		{
			return ((FlowFinalNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ForkJoinNode2EditPart)
		{
			return ((ForkJoinNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof InitialNode2EditPart)
		{
			return ((InitialNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof StoryNode2EditPart)
		{
			return ((StoryNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof StructuredNode2EditPart)
		{
			return ((StructuredNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ActivityFinalNode2EditPart)
		{
			return ((ActivityFinalNode2EditPart) sourceEditPart).getMARelTypesOnSource();
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target)
	{
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ActivityFinalNodeEditPart)
		{
			return ((ActivityFinalNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof DecisionMergeNodeEditPart)
		{
			return ((DecisionMergeNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ExpressionActivityNodeEditPart)
		{
			return ((ExpressionActivityNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof FlowFinalNodeEditPart)
		{
			return ((FlowFinalNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ForkJoinNodeEditPart)
		{
			return ((ForkJoinNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof InitialNodeEditPart)
		{
			return ((InitialNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof StoryNodeEditPart)
		{
			return ((StoryNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof StructuredNodeEditPart)
		{
			return ((StructuredNodeEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof StoryPatternObjectEditPart)
		{
			return ((StoryPatternObjectEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof DecisionMergeNode2EditPart)
		{
			return ((DecisionMergeNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ExpressionActivityNode2EditPart)
		{
			return ((ExpressionActivityNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof FlowFinalNode2EditPart)
		{
			return ((FlowFinalNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ForkJoinNode2EditPart)
		{
			return ((ForkJoinNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof InitialNode2EditPart)
		{
			return ((InitialNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof StoryNode2EditPart)
		{
			return ((StoryNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof StructuredNode2EditPart)
		{
			return ((StructuredNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ActivityFinalNode2EditPart)
		{
			return ((ActivityFinalNode2EditPart) targetEditPart).getMARelTypesOnTarget();
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source, IAdaptable target)
	{
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ActivityFinalNodeEditPart)
		{
			return ((ActivityFinalNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof DecisionMergeNodeEditPart)
		{
			return ((DecisionMergeNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ExpressionActivityNodeEditPart)
		{
			return ((ExpressionActivityNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof FlowFinalNodeEditPart)
		{
			return ((FlowFinalNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ForkJoinNodeEditPart)
		{
			return ((ForkJoinNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof InitialNodeEditPart)
		{
			return ((InitialNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof StoryNodeEditPart)
		{
			return ((StoryNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof StructuredNodeEditPart)
		{
			return ((StructuredNodeEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof StoryPatternObjectEditPart)
		{
			return ((StoryPatternObjectEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof DecisionMergeNode2EditPart)
		{
			return ((DecisionMergeNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ExpressionActivityNode2EditPart)
		{
			return ((ExpressionActivityNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof FlowFinalNode2EditPart)
		{
			return ((FlowFinalNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ForkJoinNode2EditPart)
		{
			return ((ForkJoinNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof InitialNode2EditPart)
		{
			return ((InitialNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof StoryNode2EditPart)
		{
			return ((StoryNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof StructuredNode2EditPart)
		{
			return ((StructuredNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ActivityFinalNode2EditPart)
		{
			return ((ActivityFinalNode2EditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForSource(IAdaptable target, IElementType relationshipType)
	{
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ActivityFinalNodeEditPart)
		{
			return ((ActivityFinalNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof DecisionMergeNodeEditPart)
		{
			return ((DecisionMergeNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ExpressionActivityNodeEditPart)
		{
			return ((ExpressionActivityNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof FlowFinalNodeEditPart)
		{
			return ((FlowFinalNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ForkJoinNodeEditPart)
		{
			return ((ForkJoinNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof InitialNodeEditPart)
		{
			return ((InitialNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof StoryNodeEditPart)
		{
			return ((StoryNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof StructuredNodeEditPart)
		{
			return ((StructuredNodeEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof StoryPatternObjectEditPart)
		{
			return ((StoryPatternObjectEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof DecisionMergeNode2EditPart)
		{
			return ((DecisionMergeNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ExpressionActivityNode2EditPart)
		{
			return ((ExpressionActivityNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof FlowFinalNode2EditPart)
		{
			return ((FlowFinalNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ForkJoinNode2EditPart)
		{
			return ((ForkJoinNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof InitialNode2EditPart)
		{
			return ((InitialNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof StoryNode2EditPart)
		{
			return ((StoryNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof StructuredNode2EditPart)
		{
			return ((StructuredNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ActivityFinalNode2EditPart)
		{
			return ((ActivityFinalNode2EditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source, IElementType relationshipType)
	{
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ActivityFinalNodeEditPart)
		{
			return ((ActivityFinalNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof DecisionMergeNodeEditPart)
		{
			return ((DecisionMergeNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ExpressionActivityNodeEditPart)
		{
			return ((ExpressionActivityNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof FlowFinalNodeEditPart)
		{
			return ((FlowFinalNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ForkJoinNodeEditPart)
		{
			return ((ForkJoinNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof InitialNodeEditPart)
		{
			return ((InitialNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof StoryNodeEditPart)
		{
			return ((StoryNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof StructuredNodeEditPart)
		{
			return ((StructuredNodeEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof StoryPatternObjectEditPart)
		{
			return ((StoryPatternObjectEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof DecisionMergeNode2EditPart)
		{
			return ((DecisionMergeNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ExpressionActivityNode2EditPart)
		{
			return ((ExpressionActivityNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof FlowFinalNode2EditPart)
		{
			return ((FlowFinalNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ForkJoinNode2EditPart)
		{
			return ((ForkJoinNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof InitialNode2EditPart)
		{
			return ((InitialNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof StoryNode2EditPart)
		{
			return ((StoryNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof StructuredNode2EditPart)
		{
			return ((StructuredNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ActivityFinalNode2EditPart)
		{
			return ((ActivityFinalNode2EditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target, IElementType relationshipType)
	{
		return selectExistingElement(target, getTypesForSource(target, relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source, IElementType relationshipType)
	{
		return selectExistingElement(source, getTypesForTarget(source, relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types)
	{
		if (types.isEmpty())
		{
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host.getAdapter(IGraphicalEditPart.class);
		if (editPart == null)
		{
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		HashSet<EObject> elements = new HashSet<EObject>();
		for (Iterator<EObject> it = diagram.getElement().eAllContents(); it.hasNext();)
		{
			EObject element = it.next();
			if (isApplicableElement(element, types))
			{
				elements.add(element);
			}
		}
		if (elements.isEmpty())
		{
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types)
	{
		IElementType type = ElementTypeRegistry.getInstance().getElementType(element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements)
	{
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(MlsdmDiagramEditorPlugin.getInstance()
				.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(shell, labelProvider);
		dialog.setMessage(Messages.MlsdmModelingAssistantProviderMessage);
		dialog.setTitle(Messages.MlsdmModelingAssistantProviderTitle);
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK)
		{
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
