/**
 */
package de.mdelab.mlsdm.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionNotEmptyOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.SetValue.Accumulator;
import org.eclipse.ocl.pivot.values.TupleValue;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.StructuredNode;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Final Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityFinalNodeImpl#getOutputParameterValues <em>Output Parameter Values</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityFinalNodeImpl#getActivity <em>Activity</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivityFinalNodeImpl extends ActivityNodeImpl implements ActivityFinalNode {
	/**
	 * The cached value of the '{@link #getOutputParameterValues()
	 * <em>Output Parameter Values</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOutputParameterValues()
	 * @generated
	 * @ordered
	 */
	protected EList<OutputParameterValue> outputParameterValues;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityFinalNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACTIVITY_FINAL_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<OutputParameterValue> getOutputParameterValues() {
		if (outputParameterValues == null) {
			outputParameterValues = new EObjectContainmentWithInverseEList<OutputParameterValue>(
					OutputParameterValue.class, this, MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES,
					MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE);
		}
		return outputParameterValues;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public Activity getActivity() {
		ActivityNodeContainer container = this.getActivityNodeContainer();

		while (container instanceof StructuredNode) {
			container = ((StructuredNode) container).getActivityNodeContainer();
		}

		assert container instanceof Activity;

		return (Activity) container;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean IncomingEdge(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityFinalNode::IncomingEdge";
		try {
			/**
			 *
			 * inv IncomingEdge:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.incomingEdges->notEmpty()
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The activity final node ' +
			 *               self.toString() + ' must have at least one incoming edge', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_FINAL_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> incomingEdges = this.getIncomingEdges();
				final /*@NonInvalid*/ SetValue BOXED_incomingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, incomingEdges);
				final /*@NonInvalid*/ boolean notEmpty = CollectionNotEmptyOperation.INSTANCE
						.evaluate(BOXED_incomingEdges).booleanValue();
				/*@NonInvalid*/ Boolean status;
				if (notEmpty) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_activity_32_final_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean NoOutputParameterValue(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityFinalNode::NoOutputParameterValue";
		try {
			/**
			 *
			 * inv NoOutputParameterValue:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.activity.parameters->select(e | e.direction <> ActivityParameterDirectionEnum::IN)
			 *             ->forAll(e |
			 *               self.outputParameterValues->exists(e2 | e2.parameter = e))
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'An output parameter value is missing for parameters of activity final node ' +
			 *               self.toString(), status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_FINAL_NODE___NO_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ Activity activity = this.getActivity();
				final /*@NonInvalid*/ List<ActivityParameter> parameters = activity.getParameters();
				final /*@NonInvalid*/ SetValue BOXED_parameters = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityParameter, parameters);
				/*@Thrown*/ Accumulator accumulator = ValueUtil
						.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityParameter);
				Iterator<Object> ITERATOR_e_0 = BOXED_parameters.iterator();
				/*@NonInvalid*/ SetValue select;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						select = accumulator;
						break;
					}
					/*@NonInvalid*/ ActivityParameter e_0 = (ActivityParameter) ITERATOR_e_0.next();
					/**
					 * e.direction <> ActivityParameterDirectionEnum::IN
					 */
					final /*@NonInvalid*/ ActivityParameterDirectionEnum direction = e_0.getDirection();
					final /*@NonInvalid*/ EnumerationLiteralId BOXED_direction = MlsdmTables.ENUMid_ActivityParameterDirectionEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(direction.getName()));
					final /*@NonInvalid*/ boolean ne = BOXED_direction != MlsdmTables.ELITid_IN;
					//
					if (ne) {
						accumulator.add(e_0);
					}
				}
				/*@Thrown*/ Object accumulator_0 = ValueUtil.TRUE_VALUE;
				Iterator<Object> ITERATOR_e_1 = select.iterator();
				/*@Thrown*/ Boolean forAll;
				while (true) {
					if (!ITERATOR_e_1.hasNext()) {
						if (accumulator_0 == null) {
							forAll = null;
						} else if (accumulator_0 == ValueUtil.TRUE_VALUE) {
							forAll = ValueUtil.TRUE_VALUE;
						} else {
							throw (InvalidValueException) accumulator_0;
						}
						break;
					}
					/*@NonInvalid*/ ActivityParameter e_1 = (ActivityParameter) ITERATOR_e_1.next();
					/**
					 *
					 * self.outputParameterValues->exists(e2 | e2.parameter = e)
					 */
					final /*@NonInvalid*/ List<OutputParameterValue> outputParameterValues = this
							.getOutputParameterValues();
					final /*@NonInvalid*/ SetValue BOXED_outputParameterValues = idResolver
							.createSetOfAll(MlsdmTables.SET_CLSSid_OutputParameterValue, outputParameterValues);
					/*@Thrown*/ Object accumulator_1 = ValueUtil.FALSE_VALUE;
					Iterator<Object> ITERATOR_e2 = BOXED_outputParameterValues.iterator();
					/*@NonInvalid*/ Boolean exists;
					while (true) {
						if (!ITERATOR_e2.hasNext()) {
							if (accumulator_1 == ValueUtil.FALSE_VALUE) {
								exists = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator_1;
							}
							break;
						}
						/*@NonInvalid*/ OutputParameterValue e2 = (OutputParameterValue) ITERATOR_e2.next();
						/**
						 * e2.parameter = e
						 */
						final /*@NonInvalid*/ ActivityParameter parameter = e2.getParameter();
						final /*@NonInvalid*/ boolean eq = parameter.equals(e_1);
						//
						if (eq) { // Normal successful body evaluation result
							exists = ValueUtil.TRUE_VALUE;
							break; // Stop immediately
						} else if (!eq) { // Normal unsuccessful body evaluation result
							; // Carry on
						} else { // Impossible badly typed result
							accumulator_1 = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
						}
					}
					//
					if (exists == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						forAll = ValueUtil.FALSE_VALUE;
						break; // Stop immediately
					} else if (exists == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						; // Carry on
					} else if (exists == null) { // Abnormal null body evaluation result
						if (accumulator_0 == ValueUtil.TRUE_VALUE) {
							accumulator_0 = null; // Cache a null failure
						}
					} else { // Impossible badly typed result
						accumulator_0 = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
					}
				}
				if (forAll == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (forAll) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE.evaluate(
							MlsdmTables.STR_An_32_output_32_parameter_32_value_32_is_32_missing_32_for_32_parameters_32_of_32_activity_32,
							toString);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean OutgoingEdge(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityFinalNode::OutgoingEdge";
		try {
			/**
			 *
			 * inv OutgoingEdge:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.outgoingEdges->isEmpty()
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The activity final node ' +
			 *               self.toString() + ' must not have an outgoing edge', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_FINAL_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, outgoingEdges);
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges).booleanValue();
				/*@NonInvalid*/ Boolean status;
				if (isEmpty) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_activity_32_final_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_not_32_have_32_an_32_outgoing_32_edge);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean OneOutputParameterValue(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityFinalNode::OneOutputParameterValue";
		try {
			/**
			 *
			 * inv OneOutputParameterValue:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.outputParameterValues->forAll(e |
			 *               self.outputParameterValues->select(e2 | e2.parameter = e.parameter)
			 *               ->size() = 1)
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'There may only be one output parameter value for each parameter of activity final node ' +
			 *               self.toString(), status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_FINAL_NODE___ONE_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ List<OutputParameterValue> outputParameterValues = this
						.getOutputParameterValues();
				final /*@NonInvalid*/ SetValue BOXED_outputParameterValues = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_OutputParameterValue, outputParameterValues);
				/*@Thrown*/ Object accumulator = ValueUtil.TRUE_VALUE;
				Iterator<Object> ITERATOR_e_0 = BOXED_outputParameterValues.iterator();
				/*@NonInvalid*/ Boolean forAll;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						if (accumulator == ValueUtil.TRUE_VALUE) {
							forAll = ValueUtil.TRUE_VALUE;
						} else {
							throw (InvalidValueException) accumulator;
						}
						break;
					}
					/*@NonInvalid*/ OutputParameterValue e_0 = (OutputParameterValue) ITERATOR_e_0.next();
					/**
					 *
					 * self.outputParameterValues->select(e2 | e2.parameter = e.parameter)
					 * ->size() = 1
					 */
					/*@Thrown*/ Accumulator accumulator_0 = ValueUtil
							.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_OutputParameterValue);
					Iterator<Object> ITERATOR_e2 = BOXED_outputParameterValues.iterator();
					/*@NonInvalid*/ SetValue select;
					while (true) {
						if (!ITERATOR_e2.hasNext()) {
							select = accumulator_0;
							break;
						}
						/*@NonInvalid*/ OutputParameterValue e2 = (OutputParameterValue) ITERATOR_e2.next();
						/**
						 * e2.parameter = e.parameter
						 */
						final /*@NonInvalid*/ ActivityParameter parameter = e2.getParameter();
						final /*@NonInvalid*/ ActivityParameter parameter_0 = e_0.getParameter();
						final /*@NonInvalid*/ boolean eq = parameter.equals(parameter_0);
						//
						if (eq) {
							accumulator_0.add(e2);
						}
					}
					final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE.evaluate(select);
					final /*@NonInvalid*/ boolean eq_0 = size.equals(MlsdmTables.INT_1);
					//
					if (!eq_0) { // Normal unsuccessful body evaluation result
						forAll = ValueUtil.FALSE_VALUE;
						break; // Stop immediately
					} else if (eq_0) { // Normal successful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
					}
				}
				if (forAll == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (forAll) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE.evaluate(
							MlsdmTables.STR_There_32_may_32_only_32_be_32_one_32_output_32_parameter_32_value_32_for_32_each_32_parameter_32,
							toString);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutputParameterValues()).basicAdd(otherEnd,
					msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES:
			return ((InternalEList<?>) getOutputParameterValues()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES:
			return getOutputParameterValues();
		case MlsdmPackage.ACTIVITY_FINAL_NODE__ACTIVITY:
			return getActivity();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES:
			getOutputParameterValues().clear();
			getOutputParameterValues().addAll((Collection<? extends OutputParameterValue>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES:
			getOutputParameterValues().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES:
			return outputParameterValues != null && !outputParameterValues.isEmpty();
		case MlsdmPackage.ACTIVITY_FINAL_NODE__ACTIVITY:
			return getActivity() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.ACTIVITY_FINAL_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP:
			return IncomingEdge((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_FINAL_NODE___NO_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP:
			return NoOutputParameterValue((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_FINAL_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP:
			return OutgoingEdge((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_FINAL_NODE___ONE_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP:
			return OneOutputParameterValue((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // ActivityFinalNodeImpl
