/**
 */
package de.mdelab.mlsdm.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionNotEmptyOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;

import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Flow Final Node</b></em>'. <!-- end-user-doc -->
 *
 * @generated
 */
public class FlowFinalNodeImpl extends ActivityNodeImpl implements FlowFinalNode {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected FlowFinalNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.FLOW_FINAL_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean FlowFinalNodeIncomingEdge(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "FlowFinalNode::FlowFinalNodeIncomingEdge";
		try {
			/**
			 *
			 * inv FlowFinalNodeIncomingEdge:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.incomingEdges->notEmpty()
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The flow final node ' +
			 *               self.toString() + ' must have at least one incoming edge', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.FLOW_FINAL_NODE___FLOW_FINAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> incomingEdges = this.getIncomingEdges();
				final /*@NonInvalid*/ SetValue BOXED_incomingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, incomingEdges);
				final /*@NonInvalid*/ boolean notEmpty = CollectionNotEmptyOperation.INSTANCE
						.evaluate(BOXED_incomingEdges).booleanValue();
				/*@NonInvalid*/ Boolean status;
				if (notEmpty) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_flow_32_final_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean FlowFinalNodeOutgoingEdge(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "FlowFinalNode::FlowFinalNodeOutgoingEdge";
		try {
			/**
			 *
			 * inv FlowFinalNodeOutgoingEdge:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.outgoingEdges->isEmpty()
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The flow final node ' +
			 *               self.toString() + ' must not have an outgoing edge', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.FLOW_FINAL_NODE___FLOW_FINAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, outgoingEdges);
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges).booleanValue();
				/*@NonInvalid*/ Boolean status;
				if (isEmpty) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_flow_32_final_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_not_32_have_32_an_32_outgoing_32_edge);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.FLOW_FINAL_NODE___FLOW_FINAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP:
			return FlowFinalNodeIncomingEdge((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.FLOW_FINAL_NODE___FLOW_FINAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP:
			return FlowFinalNodeOutgoingEdge((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // FlowFinalNodeImpl
