package de.mdelab.mlsdm.ui.expressions;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.RemoveCommand;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Widget;

import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.ui.dialogs.MLExpressionEditDialog;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityCallAction;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.MlsdmFactory;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

// ############################################################################
//
// If a new expression type or call action type was created, just create a new
// class implementing IView and add it to the VIEW_MAP.
//
// ############################################################################

public class MlsdmEditExpressionDialog extends MLExpressionEditDialog {

//	protected class ActivityCallActionView extends CallActionView {
//		
//		@Override
//		public void adaptInputElements()
//		{
//			super.adaptInputElements();
//			if (((ActivityCallAction) CommonEditExpressionDialog.this.currentTreeValue).getActivity() != null)
//			{
//				int i;
//	
//				for (i = 0; i < CommonEditExpressionDialog.this.activityValues.toArray().length; i++)
//				{
//					if (((Activity) CommonEditExpressionDialog.this.activityValues.toArray()[i]).getName() != null
//							&& ((Activity) CommonEditExpressionDialog.this.activityValues.toArray()[i]).getName().equals(
//									((ActivityCallAction) CommonEditExpressionDialog.this.currentTreeValue).getActivity()
//											.getName()))
//					{
//						break;
//					}
//				}
//	
//				CommonEditExpressionDialog.this.addOrResetActivityfield(i);
//			}
//			else
//			{
//				CommonEditExpressionDialog.this.addOrResetActivityfield(-1);
//			}
//	
//			CommonEditExpressionDialog.this.activityCombo.addSelectionListener(new SelectionListener()
//			{
//				@Override
//				public void widgetDefaultSelected(SelectionEvent e)
//				{
//					this.widgetSelected(e);
//				}
//	
//				@Override
//				public void widgetSelected(SelectionEvent e)
//				{
//					TransactionalEditingDomain domain = TransactionUtil.getEditingDomain(CommonEditExpressionDialog.this.currentTreeValue);
//	
//					MLNamedElement nElem = null;
//					Iterator<EObject> it = CommonEditExpressionDialog.this.activityValues.iterator();
//					while (it.hasNext())
//					{
//						nElem = (MLNamedElement) it.next();
//	
//						if (nElem.getName() != null && nElem.getName().equals(CommonEditExpressionDialog.this.activityCombo.getText()))
//						{
//							break;
//						}
//					}
//	
//					Command command = domain.createCommand(
//							SetCommand.class,
//							new CommandParameter(CommonEditExpressionDialog.this.currentTreeValue, MlsdmPackage.eINSTANCE.getActivityCallAction_Activity(), nElem));
//					domain.getCommandStack().execute(command);
//				}
//			});
//			//JOptionPane.showInputDialog("start: " + ((ActivityCallAction) CommonEditExpressionDialog.this.currentTreeValue).isImportOutputParameters());
//			CommonEditExpressionDialog.this.addOrResetImportOutputField(((ActivityCallAction) CommonEditExpressionDialog.this.currentTreeValue).isImportOutputParameters());
//		}
//		@Override
//		public EObject create()	{
//			return MlsdmFactory.eINSTANCE.createActivityCallAction();
//		}
//
//		@Override
//		public EClassifier getClassifier()
//		{
//			return ((ActivityCallAction) CommonEditExpressionDialog.this.currentTreeValue).getType();
//		}
//		
//		@Override
//		public void processCurrentInput()
//		{
//			super.processCurrentInput();
//			ActivityCallAction lda = (ActivityCallAction) CommonEditExpressionDialog.this.currentTreeValue;
//			if (!CommonEditExpressionDialog.this.importOutputCheckBox.getSelection()==lda.isImportOutputParameters()){
//				//JOptionPane.showInputDialog("ja: " + CommonEditExpressionDialog.this.importOutputCheckBox.getSelection());
//				TransactionalEditingDomain domain = TransactionUtil.getEditingDomain(lda);
//				Command command = domain.createCommand(SetCommand.class,
//						new CommandParameter(lda, MlsdmPackage.eINSTANCE.getActivityCallAction_ImportOutputParameters(),
//								CommonEditExpressionDialog.this.importOutputCheckBox.getSelection()));
//				domain.getCommandStack().execute(command);
//			}
//			//else JOptionPane.showInputDialog("nein");
//			/*if (!CommonEditExpressionDialog.this.classifierCombo.getText().equals(lda.getType().getName()))
//			{
//				EClassifier ec = null;
//				for (EObject e: classifierValues){
//					if (((EClassifier)e).getName().equals(CommonEditExpressionDialog.this.classifierCombo.getText())){
//						ec = (EClassifier) e;
//					}
//				}
//				if (ec != null){
//					TransactionalEditingDomain domain = TransactionUtil.getEditingDomain(lda);
//					Command command = domain.createCommand(SetCommand.class,
//							new CommandParameter(lda, MlcorePackage.eINSTANCE.getMLTypedElement_Type(),
//									ec));
//					domain.getCommandStack().execute(command);
//				}
//			}
//			else JOptionPane.showInputDialog("nein");*/
//		}	
//	}
	
	static {
		SOURCE_PACKAGES.add( MlsdmPackage.eINSTANCE );

		SUBCLASS_MAP.get( MlcallactionsPackage.Literals.CALL_ACTION.getName() ).add( MlsdmPackage.Literals.ACTIVITY_CALL_ACTION );
	}

	class ActivityCallActionView extends CallActionView	{
		
		@Override
		public void adaptInputElements()
		{
			super.adaptInputElements();
			
			if (((ActivityCallAction) currentTreeValue).getReturnValueParameter() != null)
			{
				int i;
				
				for (i = 0; i <  activityParameterValues.toArray().length; i++)
				{
					if (((ActivityParameter) activityParameterValues.toArray()[i]).getName().equals(
							((ActivityCallAction) currentTreeValue).getReturnValueParameter().getName()))
					{
						break;
					}
				}
				
				addOrResetActivityParameterFieldWithCheckBox(i);
			}
			else
			{
				addOrResetActivityParameterFieldWithCheckBox(-1);
			}
			
			activityCheckBox.setSelection(((ActivityCallAction) currentTreeValue).isImportOutputParameters());

			activityParameterCombo.addSelectionListener(createComboSelectionListener(MlsdmPackage.eINSTANCE.getActivityCallAction_ReturnValueParameter(),
							activityParameterCombo, activityParameterValues));
			activityCheckBox.addSelectionListener(createButtonSelectionListener(MlsdmPackage.eINSTANCE.getActivityCallAction_ReturnValueParameter(),
							activityCheckBox, ((ActivityCallAction) currentTreeValue)));
		}

		@Override
		public EObject create() {
			return MlsdmFactory.eINSTANCE.createActivityCallAction();
		}
	}

	protected Activity activity;
	
	private Composite activityParameterField;

	protected Combo	activityParameterCombo;//, activityCombo;
	private Collection<EObject> activityParameterValues;//, activityValues;
	
	protected Button activityCheckBox;
	
	//private Composite activityField;
	private Label activityParameterLabel;//, activityLabel;
	
	public MlsdmEditExpressionDialog(	final Shell parent,
										final AdapterFactory adapterFactory )	{
		super( parent, adapterFactory );

		this.VIEW_MAP.put(MlsdmPackage.Literals.ACTIVITY_CALL_ACTION.getName(), new ActivityCallActionView());
	}

//	@Override
//	protected void createValues() {
//		super.createValues();
//		
//		if ( this.rootContainer!=null) {
//			this.activityValues = ItemPropertyDescriptor.getReachableObjectsOfType(this.rootContainer,
//					MlsdmPackage.eINSTANCE.getActivity());
//		}
//		
//		if (this.rootContainer!=null) {
//			this.activityParameterValues = ItemPropertyDescriptor.getReachableObjectsOfType(this.rootContainer,
//					MlsdmPackage.eINSTANCE.getActivityParameter());
//		}
//	}
//
//	private void addOrResetActivityfield(int selection)
//	{
//		this.activityField = new Composite(this.lower, SWT.NONE);
//		this.activityField.setLayout(new GridLayout(1, true));
//		this.activityField.setLayoutData(new GridData(GridData.FILL, GridData.BEGINNING, true, false));
//
//		this.activityLabel = new Label(this.activityField, SWT.NONE);
//		this.activityLabel.setText("Activity:");
//		this.activityLabel.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, false));
//
//		this.activityCombo = new Combo(this.activityField, SWT.READ_ONLY);
//		GridData gdTxtvarname = new GridData(GridData.FILL, GridData.FILL, true, true);
//		gdTxtvarname.verticalSpan = 4;
//		this.activityCombo.setLayoutData(gdTxtvarname);
//
//		if (this.activityValues!=null){
//			if (this.activityValues.size()>0){
//				for (EObject a : this.activityValues)
//				{
//					if (((Activity) a).getName() != null)
//					{
//						this.activityCombo.add(((Activity) a).getName());
//					}
//				}
//		
//				this.activityCombo.select(selection);
//			}
//		}
//	}
	
//	protected void addOrResetActivityParameterFieldWithCheckBox(int selection)
//	{
//		this.activityParameterField = new Composite(this.lower, SWT.NONE);
//		this.activityParameterField.setLayout(new GridLayout(1, true));
//		this.activityParameterField.setLayoutData(new GridData(GridData.FILL, GridData.BEGINNING, true, false));
//
//		this.activityParameterLabel = new Label(this.activityParameterField, SWT.NONE);
//		this.activityParameterLabel.setText("Return Parameter:");
//		this.activityParameterLabel.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, false));
//
//		
//		this.activityParameterCombo = new Combo(this.activityParameterField, SWT.READ_ONLY);
//		GridData gdTxtvarname = new GridData(GridData.FILL, GridData.FILL, true, true);
//		gdTxtvarname.verticalSpan = 4;
//		this.activityParameterCombo.setLayoutData(gdTxtvarname);
//
//		for (EObject a : this.activityParameterValues)
//		{
//			if (((ActivityParameter) a).getName() != null)
//			{
//				this.activityParameterCombo.add(((ActivityParameter) a).getName());
//			}
//		}
//
//		this.activityParameterCombo.select(selection);
//		
//		this.activityCheckBox = new Button(this.activityParameterField, SWT.CHECK);
//		this.activityCheckBox.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
//		this.activityCheckBox.setText("import output parameters");
//	}
	
//	@Override
	protected void addOrResetActivityParameterFieldWithCheckBox(int selection)
	{
		this.activityParameterField = new Composite(this.lower, SWT.NONE);
		this.activityParameterField.setLayout(new GridLayout(1, true));
		this.activityParameterField.setLayoutData(new GridData(GridData.FILL, GridData.BEGINNING, true, false));

		this.activityParameterLabel = new Label(this.activityParameterField, SWT.NONE);
		this.activityParameterLabel.setText("Return Parameter:");
		this.activityParameterLabel.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, false));

		
		this.activityParameterCombo = new Combo(this.activityParameterField, SWT.READ_ONLY);
		GridData gdTxtvarname = new GridData(GridData.FILL, GridData.FILL, true, true);
		gdTxtvarname.verticalSpan = 4;
		this.activityParameterCombo.setLayoutData(gdTxtvarname);

		for (EObject a : this.activityParameterValues)
		{
			if (((ActivityParameter) a).getName() != null)
			{
				this.activityParameterCombo.add(((ActivityParameter) a).getName());
			}
		}

		this.activityParameterCombo.select(selection);
		
		this.activityCheckBox = new Button(this.activityParameterField, SWT.CHECK);
		this.activityCheckBox.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
		this.activityCheckBox.setText("import output parameters");
	}
	
	@Override
	protected Widget[] getControlElements() {
		final Collection<Widget> controlElements = new ArrayList<Widget>( Arrays.asList( super.getControlElements() ) );
		controlElements.add( this.activityParameterField );
		
		return controlElements.toArray( new Widget[ controlElements.size()] );
	}

	@Override
	protected void changeTreePositions(boolean direction){ //direction = true = "up"; direction = false = "down"
		if (callActionTypeCombobox.getSelectionIndex() == -1)
		{
			return;
		}
		TreeItem ti = currentTreeItem;
		StoryPatternObject spo = (StoryPatternObject) ti.getParentItem().getData();
		TransactionalEditingDomain domain;
		int size = spo.getConstraints().size();
		int oldPos = -1;
		int newPos = -1;
		MLExpression[] expressions = new MLExpression[size];
		
		for (int i=0; i<size;i++){
			expressions[i] = spo.getConstraints().get(i);
			if (expressions[i].equals(ti.getData())){
				if (direction){
					newPos = (i-1+size)%size;
				}
				else
				{
					newPos = (i+1)%size;
				}
				oldPos = i;
			}
		}
		// remove old constraints
		for (int j = 0; j<size;j++){
			domain = TransactionUtil.getEditingDomain(spo);
			domain.getCommandStack().execute(
					new RemoveCommand(domain, spo, spo.eClass()
							.getEStructuralFeature("constraints"), expressions[j]));
		}
		
		// change positions
		MLExpression ex = expressions[oldPos];
		expressions[oldPos] = expressions[newPos];
		expressions[newPos]=ex;
		
		// add new constraints
		for (int j = 0; j<size;j++){
			domain = TransactionUtil.getEditingDomain(spo);
			domain.getCommandStack().execute(
					new AddCommand(domain, spo, spo.eClass()
							.getEStructuralFeature("constraints"), expressions[j]));
		}
		
//		if (callActionHierarchie.getTree().getItem(0).getItemCount() > 0)
//		{
		for (TreeItem treeItem : callActionHierarchie.getTree().getItem(0).getItems())
		{
			if (treeItem.getData().equals(expressions[oldPos]))
			{
				callActionHierarchie.getTree().select(treeItem);
				selectionChanged(treeItem);
				break;
			}
//			}
		}
	}
//	
//	@Override
//	protected void addOrResetStringExpressionEditor(String string, String content) {
//		this.constraintLanguages = ExpressionsUtils.getAvailableExpressionLanguages();
//		super.addOrResetStringExpressionEditor(string, content);
//	}
	
	@Override
	protected void createCallActionHierarchie(){
		this.callActionHierarchie = new TreeViewer(this.upper, SWT.NONE); 

		GridData gridData = new GridData(GridData.FILL, GridData.FILL, true, true, 3, 1);
		gridData.minimumWidth = 500;
		gridData.minimumHeight = 200;
		gridData.widthHint = 500;
		gridData.heightHint = 200;
		this.callActionHierarchie.getTree().setLayoutData(gridData);
		
		//final ComposedAdapterFactory adapterFactory = new ComposedAdapterFactory( ComposedAdapterFactory.Descriptor.Registry.INSTANCE );
		callActionHierarchie.setContentProvider( new AdapterFactoryContentProvider( adapterFactory ) );
//
//		this.callActionHierarchie.setContentProvider(new AdapterFactoryContentProvider(MlsdmDiagramEditorPlugin.getInstance()
//				.getItemProvidersAdapterFactory()));
		callActionHierarchie.setLabelProvider(new AdapterFactoryLabelProvider.ColorProvider( adapterFactory, callActionHierarchie ) );
//		this.callActionHierarchie.setLabelProvider(new AdapterFactoryLabelProvider.ColorProvider(MlsdmDiagramEditorPlugin
//				.getInstance().getItemProvidersAdapterFactory(), this.callActionHierarchie));

		if ( expressionOwner != null ) {
			this.callActionHierarchie.setInput( expressionOwner.eContainer() );
			ViewerFilter[] viewerFilters = new ViewerFilter[1];
			viewerFilters[0] = new ViewerFilter()
			{

				@Override
				public boolean select(Viewer viewer, Object parentElement, Object element)
				{
					//if (element instanceof MLStringExpression && element != MlsdmEditExpressionDialog.this.expression)
					//	return false;
					
					EObject container = (EObject) element;
					while (container!=null && container != expression)
						container = container.eContainer();
					if (container == expression)
						return true;
					return false;
				}
			};
			this.callActionHierarchie.setFilters(viewerFilters);
		}

		// creating Listener for the TreeItems
		SelectionListener stdTreeItemlistener = createSelectionListener();
		this.callActionHierarchie.getTree().addSelectionListener(stdTreeItemlistener);

	}
	
	@Override
	protected SelectionListener createSelectionListener(){
		final SelectionListener stdTreeItemlistener = new SelectionListener() {
			
			@Override
			public void widgetDefaultSelected(SelectionEvent event)
			{
				this.widgetSelected(event);
			}

			@Override
			public void widgetSelected(SelectionEvent event)
			{
				processCurrentInput();
				selectionChanged(event.item);
				upButton.setEnabled(false);
				downButton.setEnabled(false);		
				
				if (((TreeItem)event.item).getParentItem()!= null)
					if (((TreeItem)event.item).getParentItem().getData() instanceof StoryPatternObject){
						upButton.setEnabled(true);
						downButton.setEnabled(true);
					}
			}
		};
		
		return stdTreeItemlistener;
	}
	
	@Override
	protected void createValues() {
//		if ( this.rootContainer!=null ) {
//			this.activityValues = ItemPropertyDescriptor.getReachableObjectsOfType(this.rootContainer,
//					MlsdmPackage.eINSTANCE.getActivity());
//		}
		
		if (this.rootContainer!=null)
			this.activityParameterValues = ItemPropertyDescriptor.getReachableObjectsOfType(this.rootContainer,
					MlsdmPackage.eINSTANCE.getActivityParameter());

	}

	public void setActivity(Activity activity) {
		this.activity = activity;
		this.setRootContainer(activity);
	}

	@Override
	protected Map<String, EClassifier> getContextInformation() {
		Map<String, EClassifier> contextInfos = new HashMap<String, EClassifier>();

		if (this.activity != null) {
			/*
			 * THIS and parameters
			 */
			if (this.activity/*.getSpecification()*/ != null)
			{
//				EClass thisClass = null;//this.activity.getSpecification().getEContainingClass();

//				if (thisClass != null)
//				{
//					contextInfos.put("this", thisClass);
//				}

				for (ActivityParameter parameter : this.activity.getParameters())
				{
					if (!parameter.getDirection().getName().equals("IN") && parameter.getName() != null && !"".equals(parameter) && parameter.getType() != null)
					{
						contextInfos.put(parameter.getName(), parameter.getType());
					}
				}
			}
			else
			{
				for (ActivityParameter parameter : this.activity.getParameters())
				{
					if ((parameter.getDirection() == ActivityParameterDirectionEnum.INOUT || parameter.getDirection() == ActivityParameterDirectionEnum.OUT)
							&& parameter.getName() != null && !"".equals(parameter) && parameter.getType() != null)
					{
						contextInfos.put(parameter.getName(), parameter.getType());
					}
				}
			}

			/*
			 * Variables created in story patterns and
			 * VariableDeclarationActions
			 */
			TreeIterator<EObject> it = this.activity.eAllContents();

			while (it.hasNext())
			{
				EObject eObject = it.next();

				if (eObject instanceof StoryPatternObject)
				{
					StoryPatternObject spo = (StoryPatternObject) eObject;

					if (spo.getName() != null && !"".equals(spo.getName()) && spo.getType() != null)
					{
						contextInfos.put(spo.getName(), spo.getType());
					}
				}
			}
		}

		return contextInfos;
	}
}
